SystemOrganization addCategory: #Metaprogramacion!

Object subclass: #MetaTestClassWithoutSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaTestClassWithoutSubclasses methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 08:57'!
aNotAbstractMethod
	^ true.! !

!MetaTestClassWithoutSubclasses methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:23'!
anAbstractMethod
	^ self subclassResponsibility.! !

Object subclass: #MetaTestRootClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

MetaTestRootClass subclass: #FirstMetaTestFirstLevelSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!FirstMetaTestFirstLevelSubClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:13'!
aNotAbstractMethod
	^ self true.! !

!MetaTestRootClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:08'!
aNotAbstractMethod
	^ true.! !

!MetaTestRootClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:09'!
anAbstractMethod
	^ self subclassResponsibility.! !

MetaTestRootClass subclass: #SecondMetaTestFirstLevelSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

SecondMetaTestFirstLevelSubClass subclass: #FirstMetaTestSecondLevelSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SecondMetaTestFirstLevelSubClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:24'!
aNotAbstractMethod
	^ self true.! !

!SecondMetaTestFirstLevelSubClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:24'!
anAbstractMethod
	^ self subclassResponsibility.! !

SecondMetaTestFirstLevelSubClass subclass: #SecondMetaTestSecondLevelSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SecondMetaTestSecondLevelSubClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:18'!
aNotAbstractMethod
	^ self true.! !

!SecondMetaTestSecondLevelSubClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:18'!
anAbstractMethod
	^ self subclassResponsibility.! !

SecondMetaTestFirstLevelSubClass subclass: #ThirdMetaTestSecondLevelSubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ThirdMetaTestSecondLevelSubClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:11'!
aNotAbstractMethod
	^ self true.! !

!ThirdMetaTestSecondLevelSubClass methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:12'!
anAbstractMethod
	^ self true.! !

TestCase subclass: #MetaprogramacionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogramacionTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:15'!
aNotAbstractMethodOfMetaTestClassWithoutSubclasses
	^ MetaTestClassWithoutSubclasses compiledMethodAt: (MetaTestClassWithoutSubclasses selectors at: 2).! !

!MetaprogramacionTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:15'!
aNotAbstractMethodOfMetaTestRootClass
	^ MetaTestRootClass compiledMethodAt: (MetaTestRootClass selectors at: 2).! !

!MetaprogramacionTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:16'!
anAbstractMethodOfMetaTestClassWithoutSubclasses
	^ MetaTestClassWithoutSubclasses compiledMethodAt: (MetaTestClassWithoutSubclasses selectors at: 1).! !

!MetaprogramacionTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:16'!
anAbstractMethodOfMetaTestRootClass
	^ MetaTestRootClass compiledMethodAt: (MetaTestRootClass selectors at: 1).! !

!MetaprogramacionTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:02'!
testLookForMissingImplementorsOfAbstractMethodOnNotSubclasifiedShouldReturnAListWithTheClass

	| missingImplementors |

	missingImplementors:= Behavior lookForMissingImplementors: self anAbstractMethodOfMetaTestClassWithoutSubclasses.
	
	self assert: (missingImplementors includes: MetaTestClassWithoutSubclasses ).! !

!MetaprogramacionTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 19:30'!
testLookForMissingImplementorsOfAbstractMethodOnSubclasifiedShouldReturnAListWithTheClass

	| missingImplementors |

	missingImplementors:= Behavior lookForMissingImplementors: self anAbstractMethodOfMetaTestRootClass.
	
	self assert: (missingImplementors includes: FirstMetaTestFirstLevelSubClass ).		
	self assert: (missingImplementors includes: SecondMetaTestSecondLevelSubClass ).
	self assert: (missingImplementors includes: FirstMetaTestSecondLevelSubClass  ).
	self deny: (missingImplementors includes: MetaTestRootClass ).
	self deny: (missingImplementors includes:   SecondMetaTestFirstLevelSubClass ).	
	self deny: (missingImplementors includes: ThirdMetaTestSecondLevelSubClass ).	! !

!MetaprogramacionTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:01'!
testLookForMissingImplementorsOfNotAbstractMethodOnNotSubclasifiedClassShouldReturnEmptyList

	| missingImplementors |

	missingImplementors:= Behavior lookForMissingImplementors: self aNotAbstractMethodOfMetaTestClassWithoutSubclasses.
	
	self assert: (missingImplementors isEmpty).! !

!MetaprogramacionTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 6/24/2013 09:08'!
testLookForMissingImplementorsOfNotAbstractMethodOnSubclasifiedClassShouldReturnEmptyList

	| missingImplementors |

	missingImplementors:= Behavior lookForMissingImplementors: self aNotAbstractMethodOfMetaTestRootClass.
	
	self assert: (missingImplementors isEmpty).! !
